#pragma once

#include <Text.h>

namespace Network
{
    namespace HTTP
    {
        class Answer
        {
        private:
            Framework::Text protocol;
            int statusNumber;
            Framework::Text statusText;
            Framework::Text date;
            Framework::Text contentType;
            Framework::Text header;
            Framework::Text data;
            Framework::Text all;
            int ref;

        public:
            __declspec( dllexport ) Answer( const char *answer );

            __declspec( dllexport ) const char *getContentType() const;
            __declspec( dllexport ) const char *getData() const;
            __declspec( dllexport ) int getStatusCode() const;
            __declspec( dllexport ) const char *getStatusText() const;
            __declspec( dllexport ) const char *getDate() const;
            __declspec( dllexport ) const char *getAll() const;

            __declspec( dllexport ) Answer *getThis();
            __declspec( dllexport ) Answer *release();
        };

        class PostRequest
        {
        private:
            Framework::Text path;
            Framework::Text host;
            Framework::Text contentType;
            Framework::Text data;
            unsigned short port;
            int ref;

        public:
            __declspec( dllexport ) PostRequest( const char *path, const char *host, const char *data, const char *contentType, unsigned short port );

            __declspec( dllexport ) Answer *execute() const;

            __declspec( dllexport ) PostRequest *getThis();
            __declspec( dllexport ) PostRequest *release();
        };
    }
}